//**************************************************************
// LiteCAD Application Demo
// Main Form Unit
// harry200@gmail.com
//**************************************************************

unit main;

interface

uses
  Winapi.Windows, System.SysUtils, System.Classes, Vcl.Graphics, Vcl.Forms,
  Vcl.Controls, Vcl.Menus, Vcl.StdCtrls, Vcl.Dialogs, Vcl.Buttons, Winapi.Messages,
  Vcl.ExtCtrls, Vcl.ComCtrls, Vcl.StdActns, Vcl.ActnList, Vcl.ToolWin,
  Vcl.ImgList, System.ImageList, System.Actions, Vcl.PlatformDefaultStyleActnCtrls,
  Vcl.ActnMan, Vcl.GraphUtil,
  IniFiles, UIRibbon, UIRibbonCommands;

type
  TFormMain = class(TForm)
    LCRibbon: TUIRibbon;
    OpenDialog: TOpenDialog;
    ActionListLC: TActionList;
    ActionFileNew: TAction;
    ActionFileOpen: TAction;
    ActionFileExit: TAction;
    ActionViewCascade: TAction;
    ActionViewTileHor: TAction;
    ActionViewTileVert: TAction;
    PanelProperties: TPanel;
    SplitterLiteCAD: TSplitter;
    ActionHelp: TAction;
    ActionViewMinimizeAll: TAction;
    ActionViewSwitchWindows: TAction;
    ImageListLiteCADButtons: TImageList;
    PopupMenuLine: TPopupMenu;
    MenuItemLineSerial: TMenuItem;
    MenuItemRay: TMenuItem;
    MenuItemLineInfinity: TMenuItem;
    N7: TMenuItem;
    MenuItemSpline: TMenuItem;
    PopupMenuDim: TPopupMenu;
    MenuItemDimLeader: TMenuItem;
    N10: TMenuItem;
    MenuItemDimLine: TMenuItem;
    MenuItemDimAlign: TMenuItem;
    MenuItemDimOrd: TMenuItem;
    MenuItemDimRadius: TMenuItem;
    MenuItemDimDiameter: TMenuItem;
    MenuItemDimAngular: TMenuItem;
    PopupMenuEdit: TPopupMenu;
    MenuItemErase: TMenuItem;
    MenuItemCopy: TMenuItem;
    MenuItemCopyMove: TMenuItem;
    MenuItemCopyRotate: TMenuItem;
    MenuItemCopyScale: TMenuItem;
    MenuItemCopyMirror: TMenuItem;
    N8: TMenuItem;
    MenuItemArrayRect: TMenuItem;
    MenuItemArrayCirc: TMenuItem;
    MenuItemExplode: TMenuItem;
    MenuItemSplit: TMenuItem;
    N13: TMenuItem;
    MenuItemMove: TMenuItem;
    MenuItemRotate: TMenuItem;
    MenuItemScale: TMenuItem;
    MenuItemMirror: TMenuItem;
    MenuItemOffset: TMenuItem;
    N18: TMenuItem;
    MenuItemTrim: TMenuItem;
    MenuItemExtend: TMenuItem;
    MenuItemBreak: TMenuItem;
    MenuItemJoin: TMenuItem;
    MenuItemFillet: TMenuItem;
    N19: TMenuItem;
    MenuItemOrder: TMenuItem;
    MenuItemOrderFront: TMenuItem;
    MenuItemOrderBack: TMenuItem;
    N23: TMenuItem;
    MenuItemOrderAbove: TMenuItem;
    MenuItemOrderUnder: TMenuItem;
    MenuItemOrderSwap: TMenuItem;
    MenuItemAlignment: TMenuItem;
    MenuItemAlignmentLeft: TMenuItem;
    MenuItemAlignmentRight: TMenuItem;
    N30: TMenuItem;
    MenuItemAlignmentTop: TMenuItem;
    MenuItemAlignmentBottom: TMenuItem;
    N33: TMenuItem;
    MenuItemAlignmentCenter: TMenuItem;
    MenuItemAlignmentCenterX: TMenuItem;
    MenuItemAlignmentCenterY: TMenuItem;
    N34: TMenuItem;
    MenuItemMoveKeyboard: TMenuItem;
    PanelBottomTools: TPanel;
    ButtonGrid: TSpeedButton;
    ButtonSnap: TSpeedButton;
    ButtonOSnap: TSpeedButton;
    ButtonOrto: TSpeedButton;
    ButtonPolar: TSpeedButton;
    ButtonFullScreen: TSpeedButton;
    ButtonLineWidth: TSpeedButton;
    ButtonLanguage: TSpeedButton;
    PanelXY: TPanel;
    LabelCoords: TLabel;
    ToolBarLiteCADRight: TToolBar;
    ToolButtonProperties: TToolButton;
    ToolButtonRuler: TToolButton;
    ToolButtonMagnifier: TToolButton;
    ToolButtonAerial: TToolButton;
    ToolButtonCMD: TToolButton;
    Separator01: TToolButton;
    ToolButtonGrid: TToolButton;
    ToolButtonOSnap: TToolButton;
    ToolButtonPolar: TToolButton;
    Separator02: TToolButton;
    ToolButtonDistance: TToolButton;
    ToolButtonArea: TToolButton;
    ToolButtonRPolygon: TToolButton;
    Separator03: TToolButton;
    ToolButtonSelOptions: TToolButton;
    ToolButtonDrawOptions: TToolButton;
    ToolBarLiteCADTop: TToolBar;
    ToolButtonNew: TToolButton;
    ToolButtonOpen: TToolButton;
    ToolButtonSave: TToolButton;
    ToolButtonRasterize: TToolButton;
    Separator7: TToolButton;
    ToolButtonPrint: TToolButton;
    Separator1: TToolButton;
    ToolButtonCut: TToolButton;
    ToolButtonCopy: TToolButton;
    ToolButtonPaste: TToolButton;
    Separator2: TToolButton;
    ToolButtonUndo: TToolButton;
    ToolButtonRedo: TToolButton;
    Separator3: TToolButton;
    ToolButtonZoomEx: TToolButton;
    ToolButtonZoomWnd: TToolButton;
    ToolButtonZoomPrev: TToolButton;
    Separator4: TToolButton;
    ToolButtonLayers: TToolButton;
    ToolButtonLayersOrder: TToolButton;
    ToolButtonColors: TToolButton;
    ToolButtonLineTypes: TToolButton;
    ToolButtonTextStyles: TToolButton;
    ToolButtonPointStyles: TToolButton;
    ToolButtonDimStyles: TToolButton;
    ToolButtonImages: TToolButton;
    Separator5: TToolButton;
    ToolButtonBlocks: TToolButton;
    ToolButtonBlockInsert: TToolButton;
    ToolButtonBlockMake: TToolButton;
    Separator6: TToolButton;
    ToolButtonPoint: TToolButton;
    ToolButtonLine: TToolButton;
    ToolButtonPolyline: TToolButton;
    ToolButtonRectangle: TToolButton;
    ToolButtonCircle: TToolButton;
    ToolButtonArc: TToolButton;
    ToolButtonEllipse: TToolButton;
    ToolButtonText: TToolButton;
    ToolButtonTextArc: TToolButton;
    ToolButtonMText: TToolButton;
    ToolButtonHatch: TToolButton;
    Separator8: TToolButton;
    ToolButtonMenuDim: TToolButton;
    ToolButtonMenuEdit: TToolButton;
    ActionFileSave: TAction;
    ActionFileSaveAs: TAction;
    ActionFileClose: TAction;
    LabelPixelSize: TLabel;
    LabelVisibleArea: TLabel;
    ActionFileOpenRecent: TAction;
    ToolButtonSaveAs: TToolButton;
    ToolButtonOpenRecent: TToolButton;
    ActionDrawLine: TAction;
    ActionDrawLineSerial: TAction;
    ActionDrawLineSeparate: TAction;
    ActionDrawCircleR: TAction;
    ActionDrawCircle2: TAction;
    ActionDrawCircle3: TAction;
    ActionDrawCircle: TAction;
    ActionHelpAPIReference: TAction;
    ActionDrawArcCONT: TAction;
    ActionDrawArcCSE: TAction;
    ActionDrawArcSEC: TAction;
    ActionDrawArcSED: TAction;
    ActionDrawArcSEM: TAction;
    ActionDrawArcSME: TAction;
    ActionDrawArc: TAction;
    ActionDrawRectangle: TAction;
    ActionDrawRectangle2: TAction;
    ActionDrawRectangle3: TAction;
    ActionDrawRectangleCSA: TAction;
    ActionDrawPolyline: TAction;
    ActionDrawPolylineSpline: TAction;
    ActionDrawPolylinePline: TAction;
    ActionDrawPolylineFile: TAction;
    ActionDrawEllipse: TAction;
    ActionDrawEllipseAX: TAction;
    ActionDrawEllipseCEN: TAction;
    ActionDrawEllipseRECT: TAction;
    ActionDrawPoint: TAction;
    ActionDrawLineRay: TAction;
    ActionDrawLineConstruction: TAction;
    ActionViewZoomExtents: TAction;
    ActionViewZoomWindow: TAction;
    ActionViewZoomPrevious: TAction;
    ActionToolsDistance: TAction;
    ActionToolsArea: TAction;
    ActionToolsRasterize: TAction;
    ActionToolsPlugins: TAction;
    ActionViewProperties: TAction;
    ActionViewRulers: TAction;
    ActionViewMagnifier: TAction;
    ActionViewAerial: TAction;
    ActionToolsSketch: TAction;
    ActionToolsPolygon: TAction;
    ActionHelpAbout: TAction;
    ActionFormatColor: TAction;
    ActionFormatMTextStyles: TAction;
    ActionFormatDimensionStyles: TAction;
    ActionFormatFillingStyles: TAction;
    ActionFormatLineTypes: TAction;
    ActionFormatPointStyles: TAction;
    ActionFormatRasterImages: TAction;
    ActionFormatTextStyles: TAction;
    ActionLayerOrder: TAction;
    ActionLayers: TAction;
    ActionAnnotationText: TAction;
    ActionAnnotationArcText: TAction;
    ActionAnnotationMText: TAction;
    ActionDimAligned: TAction;
    ActionDimAngular: TAction;
    ActionDimDiameter: TAction;
    ActionDimLeader: TAction;
    ActionDimLinear: TAction;
    ActionDimOrdinate: TAction;
    ActionDimRadius: TAction;
    ActionDrawHatch: TAction;
    ActionAnnotationArrow: TAction;
    ActionLayouts: TAction;
    ActionBlocks: TAction;
    ActionBlockInsert: TAction;
    ActionBlockCreate: TAction;
    ActionFilePrint: TAction;
    ActionBlockExternalRef: TAction;
    ActionViewClassicToolBar: TAction;
    ActionModifyAlignmentBottom: TAction;
    ActionModifyAlignmentCenter: TAction;
    ActionModifyAlignmentCenterX: TAction;
    ActionModifyAlignmentCenterY: TAction;
    ActionModifyAlignmentLeft: TAction;
    ActionModifyAlignmentRight: TAction;
    ActionModifyAlignmentTop: TAction;
    ActionModifyOrderAbove: TAction;
    ActionModifyOrderBringToFront: TAction;
    ActionModifyOrderSendToBack: TAction;
    ActionModifyOrderSwap: TAction;
    ActionModifyOrderUnder: TAction;
    ActionModifyCopyArrayCirc: TAction;
    ActionModifyCopyArrayRect: TAction;
    ActionModifyCopyMirror: TAction;
    ActionModifyCopyScale: TAction;
    ActionModifyCopyMove: TAction;
    ActionModifyCopyRotate: TAction;
    ActionModifyErase: TAction;
    ActionModifyExplode: TAction;
    ActionModifySplit: TAction;
    ActionModifyMove: TAction;
    ActionModifyRotate: TAction;
    ActionModifyScale: TAction;
    ActionModifyMirror: TAction;
    ActionModifyOffset: TAction;
    ActionModifyTrim: TAction;
    ActionModifyExtend: TAction;
    ActionModifyBreak: TAction;
    ActionModifyJoin: TAction;
    ActionModifyFillet: TAction;
    ActionViewGrid: TAction;
    ActionViewOSnap: TAction;
    ActionViewPolar: TAction;
    ActionViewSelection: TAction;
    ActionViewDrawingParam: TAction;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ActionFileNewExecute(Sender: TObject);
    procedure ActionFileOpenExecute(Sender: TObject);
    procedure ActionFileExitExecute(Sender: TObject);
    procedure ActionViewCascadeExecute(Sender: TObject);
    procedure ActionViewTileHorExecute(Sender: TObject);
    procedure ActionViewTileVertExecute(Sender: TObject);
    procedure PanelPropertiesResize(Sender: TObject);
    procedure ActionHelpExecute(Sender: TObject);
    procedure ActionViewMinimizeAllExecute(Sender: TObject);
    procedure ActionViewSwitchWindowsExecute(Sender: TObject);
    procedure ButtonLanguageClick(Sender: TObject);
    procedure ButtonLineWidthClick(Sender: TObject);
    procedure ButtonGridClick(Sender: TObject);
    procedure ButtonOSnapClick(Sender: TObject);
    procedure ButtonSnapClick(Sender: TObject);
    procedure ButtonOrtoClick(Sender: TObject);
    procedure ButtonPolarClick(Sender: TObject);
    procedure FullScreenMode;
    procedure ButtonFullScreenClick(Sender: TObject);
    procedure LCRibbonCommandCreate(const Sender: TUIRibbon; const Command: TUICommand);
    procedure LCRibbonLoaded(Sender: TObject);
    procedure ActionFileSaveExecute(Sender: TObject);
    procedure ActionFileCloseExecute(Sender: TObject);
    procedure DropDownMenuClick(Sender: TObject);
    procedure ActionFileOpenRecentExecute(Sender: TObject);
    procedure ActionFileSaveAsExecute(Sender: TObject);
    procedure ActionDrawLineSerialExecute(Sender: TObject);
    procedure ActionDrawLineSeparateExecute(Sender: TObject);
    procedure ActionDrawCircleRExecute(Sender: TObject);
    procedure ActionDrawCircle2Execute(Sender: TObject);
    procedure ActionDrawCircle3Execute(Sender: TObject);
    procedure ActionHelpAPIReferenceExecute(Sender: TObject);
    procedure ActionDrawArcSMEExecute(Sender: TObject);
    procedure ActionDrawArcSEMExecute(Sender: TObject);
    procedure ActionDrawArcSEDExecute(Sender: TObject);
    procedure ActionDrawArcSECExecute(Sender: TObject);
    procedure ActionDrawArcCSEExecute(Sender: TObject);
    procedure ActionDrawArcCONTExecute(Sender: TObject);
    procedure ActionDrawRectangle2Execute(Sender: TObject);
    procedure ActionDrawRectangle3Execute(Sender: TObject);
    procedure ActionDrawRectangleCSAExecute(Sender: TObject);
    procedure ActionDrawEllipseAXExecute(Sender: TObject);
    procedure ActionDrawEllipseCENExecute(Sender: TObject);
    procedure ActionDrawEllipseRECTExecute(Sender: TObject);
    procedure ActionDrawLineRayExecute(Sender: TObject);
    procedure ActionDrawLineConstructionExecute(Sender: TObject);
    procedure ActionViewMagnifierExecute(Sender: TObject);
    procedure ActionViewPropertiesExecute(Sender: TObject);
    procedure ActionViewRulersExecute(Sender: TObject);
    procedure ActionViewAerialExecute(Sender: TObject);
    procedure ActionHelpAboutExecute(Sender: TObject);
    procedure ActionLCExecute(Sender: TObject);
    procedure CopyExecute(Sender: TObject);
    procedure AlignmentExecute(Sender: TObject);
    procedure OrderExecute(Sender: TObject);
    procedure ActionViewClassicToolBarExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);

  private
    { Private declarations }
    curDecimalSeparator: Char;
    FRibbonRecentItems: TUICommandRecentItems;
    procedure RibbonRecentItemsClick (const Command: TUICommandRecentItems; const Verb: TUICommandVerb; const ItemIndex: Integer; const Properties: TUICommandExecutionProperties);

    procedure LoadSettings;
    procedure SaveSettings;
    procedure CreateMDIChild(const FName: string);
    function  ActiveWndExists: Boolean;
    function  ActiveWnd: IntPtr;
    procedure ActiveWndFocus;

  public
    { Public declarations }
    hwProp:      HWND;    // Handle wnd property (TPanel)
    hLcProp:     IntPtr;  // Handle Property Panel
    WND_STYLE:   Integer; // Windows Style i.e with Rulers, Tabs
    WND_OSNAPI:  Integer; // OSnap
    WND_GRIDDX:  Double;  // Distance between vertical grid lines
    WND_GRIDDY:  Double;  // Distance between horizontal grid lines

  end;

var
  FormMain: TFormMain;
  CounterNewFile: Integer;

implementation

{$R *.dfm}

uses child, litecad, RecentList, LCRibbon, res, about;

{$REGION 'Ribbon'}
// Ribbon create commands
procedure TFormMain.LCRibbonCommandCreate(const Sender: TUIRibbon; const Command: TUICommand);
begin
  inherited;
  case Command.CommandId of
    RibbonRecentItems:
      begin
        FRibbonRecentItems := Command as TUICommandRecentItems;
        FRibbonRecentItems.OnSelect := RibbonRecentItemsClick;
      end;
  end;
end;

// Set the background color of the entire form to a slightly darker
// The ColorAdjustLuma function is available in Delphi's GraphUtil unit
// Load recent list on ribbon loaded event
procedure TFormMain.LCRibbonLoaded(Sender: TObject);
begin
  inherited;
  Color := ColorAdjustLuma(LCRibbon.BackgroundColor, -10, False);
  LoadRecentList(LCRibbon);
end;

// Open recent file from Ribbon Recent List
procedure TFormMain.RibbonRecentItemsClick(const Command: TUICommandRecentItems;
                                 const Verb: TUICommandVerb; const ItemIndex: Integer;
                                 const Properties: TUICommandExecutionProperties);
begin
  CreateMDIChild(EmptyStr);
  if RecentFileExist(LCRibbon,ItemIndex) then
    if ActiveWndExists then
      if not TFormChild(ActiveMDIChild).FileOpen(MRUList[ItemIndex]) then ActiveMDIChild.Close
end;
{$ENDREGION 'Ribbon'}

{$REGION 'Settings'}
// Load Settings from Ini File
procedure TFormMain.LoadSettings;
  var
    Ini: TIniFile;
    Lng: String;
begin
  Ini:=TIniFile.Create(ExtractFilePath(Application.ExeName) + LCADIniFile);
  with Ini do
    try
      lcPropPutStr(0,LC_PROP_G_REGCODE,'Your LiteCAD regcode here');
      Lng:=ReadString('LiteCAD','LANGUAGE',DEFAULT_LANG);                              // Default Interface Language
      ActionViewClassicToolBar.Checked:= ReadBool('LiteCAD','SHOWCLASSIC',true);       // Show/Hide Classic Toolbar
      ActionViewProperties.Checked:= ReadBool('LiteCAD','SHOWPROP',true);              // Show/Hide Properties
      ActionViewRulers.Checked := ReadBool('LiteCAD','SHOWRULERS',true);               // Rulers
      ButtonGrid.Down          := ReadBool('LiteCAD','SHOWGRID',true);                 // Grid
      WND_STYLE                := ReadInteger('LiteCAD','WND_STYLE',DEFAULT_WNDSTYLE); // LC_WS_RULERS or LC_WS_VIEWTABS i.e.
      WND_OSNAPI               := ReadInteger('LiteCAD','WND_OSNAP',DEFAULT_OSNAP);    // Object snap mode
      WND_GRIDDX               := ReadFloat('LiteCAD','WND_GRIDDX', DEFAULT_GRIDDX);   // Distance between vertical grid lines
      WND_GRIDDY               := ReadFloat('LiteCAD','WND_GRIDDY', DEFAULT_GRIDDY);   // Distance between horizontal grid lines
      PanelProperties.Visible:=ActionViewProperties.Checked;                           // Show/Hide Properties
      ToolBarLiteCADRight.Visible:=ActionViewClassicToolBar.Checked;
      ToolBarLiteCADTop.Visible:=ActionViewClassicToolBar.Checked;
      if Lng=DEFAULT_LANG
        then lcStrFileLoad(PChar(LCADLangEN))
        else lcStrFileLoad(PChar(LCADLangRU));
      ButtonLanguage.Caption:=Lng;
    finally
      FreeAndNil(Ini);
    end;
end;

// Save settings to Ini File
procedure TFormMain.SaveSettings;
  var Ini: TIniFile;
begin
  Ini:=TIniFile.Create(ExtractFilePath(Application.ExeName) + LCADIniFile);
  with Ini do
    try
      WriteString('LiteCAD','LANGUAGE',ButtonLanguage.Caption);            // Default Interface Language
      WriteBool('LiteCAD','SHOWCLASSIC',ActionViewClassicToolBar.Checked); // Show/Hide Classic Toolbar
      WriteBool('LiteCAD','SHOWPROP',ActionViewProperties.Checked);        // Show/Hide Properties
      WriteBool('LiteCAD','SHOWRULERS',ActionViewRulers.Checked);          // Rulers
      WriteBool('LiteCAD','SHOWGRID',ButtonGrid.Down);                     // Grid (last state of button on bottom tool)
      WriteInteger('LiteCAD','WND_STYLE',WND_STYLE);                       // LiteCAD Wnd Style (you may change it in App code)
      WriteInteger('LiteCAD','WND_OSNAP',WND_OSNAPI);                      // Object snap mode
      WriteFloat('LiteCAD','WND_GRIDDX', WND_GRIDDX);                      // Distance between vertical grid lines
      WriteFloat('LiteCAD','WND_GRIDDY', WND_GRIDDY);                      // Distance between horizontal grid lines
    finally
      FreeAndNil(Ini);
    end;
end;
{$ENDREGION 'Settings'}

{$REGION 'Active Child Wnd'}
// Return TRUE if Active Child Wnd exists
function TFormMain.ActiveWndExists: Boolean;
begin
  Result:=(ActiveMDIChild <> nil ) and (ActiveMDIChild is TFormChild)
end;

// Return Active Child Wnd
function TFormMain.ActiveWnd: IntPtr;
begin
  Result:=0;
  if ActiveWndExists then Result:=TFormChild(ActiveMDIChild).hLcWnd
end;

// Return Active Child Drawing
//function TFormMain.ActiveDrw: IntPtr;
//begin
//  Result:=0;
//  if ActiveWndExists then Result:=TFormChild(ActiveMDIChild).hLcDrw
//end;

// Set focus on active document
procedure TFormMain.ActiveWndFocus;
begin
  if ActiveWndExists then TFormChild(ActiveMDIChild).WndFocus
end;

// Create a new MDI child window
procedure TFormMain.CreateMDIChild(const FName: string);
  var Child: TFormChild;
begin
  Child:=TFormChild.Create(Application);
  Child.Caption:=FName;
  Child.WindowState:=wsMaximized;
  Child.WndFocus;
//  if FileExists(Name) then ;
end;
{$ENDREGION 'Active Child Wnd'}

{$REGION 'Form Events'}
// FormCreate
procedure TFormMain.FormCreate(Sender: TObject);
begin
  CounterNewFile:=0;
  curDecimalSeparator:= FormatSettings.DecimalSeparator;
  Application.UpdateFormatSettings:=false;
  FormatSettings.DecimalSeparator:='.';
  MRUList := TStringList.Create;
  SetFormCaption;
  OpenDialog.Filter:=OpenDialogFilter;
  OpenDialog.Title:=MsgOpenDefaultTitle;
  hwProp:=PanelProperties.Handle;
  hLcProp:=lcCreateProps(hwProp);
  FormMain.WindowState:=wsMaximized;
  LoadSettings
end;

// FormShow
// New LC drawing on startup
procedure TFormMain.FormShow(Sender: TObject);
begin
  ActionFileNewExecute(ActionFileNew)
end;

procedure TFormMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
//  for i := 0 to MDIChildCount-1 do
//    TFormChild(MDIChildren[i]).Close; //FormClose(TFormChild(MDIChildren[i]));
//    showmessage(IntToStr(MDIChildCount))
end;

// FormDestroy
// Save Settings, Uninitialize LiteCAD
procedure TFormMain.FormDestroy(Sender: TObject);
begin
  SaveSettings;
  lcUninitialize(LC_TRUE);
  FreeAndNil(MRUList);
  FormatSettings.DecimalSeparator:=curDecimalSeparator
end;

// Set size panel properties onResize Event
procedure TFormMain.PanelPropertiesResize(Sender: TObject);
begin
  lcPropsResize(hLcProp,0,0,PanelProperties.Width,PanelProperties.Height);
end;
{$ENDREGION 'Form Events'}

{$REGION 'Bottom Tools'}
// Interface Language
procedure TFormMain.ButtonLanguageClick(Sender: TObject);
begin
  if ButtonLanguage.Caption=LangRU
    then lcStrFileLoad(PChar(LCADLangEN))
    else lcStrFileLoad(PChar(LCADLangRU));
  if ButtonLanguage.Caption=LangRU
    then ButtonLanguage.Caption:=LCADLangDefault
    else ButtonLanguage.Caption:=LangRU;
end;

// LineWidth
procedure TFormMain.ButtonLineWidthClick(Sender: TObject);
begin
  if ActiveWndExists then
    begin
      if ButtonLineWidth.Down
        then lcPropPutInt(TFormChild(ActiveMDIChild).hLcDrw,LC_PROP_DRW_LWMODE,LC_LW_REAL)
        else lcPropPutInt(TFormChild(ActiveMDIChild).hLcDrw,LC_PROP_DRW_LWMODE,LC_LW_THIN);
      lcWndRedraw(TFormChild(ActiveMDIChild).hLcWnd)
    end;
end;

// Grid (F7, Ctrl+G)
procedure TFormMain.ButtonGridClick(Sender: TObject);
begin
  if ActiveWndExists then
    begin
      lcPropPutBool(TFormChild(ActiveMDIChild).hLcWnd,LC_PROP_WND_GRIDSHOW,Integer(ButtonGrid.Down));
      lcWndRedraw(TFormChild(ActiveMDIChild).hLcWnd)
    end;
end;

// Object snap (F3)
procedure TFormMain.ButtonOSnapClick(Sender: TObject);
begin
  if ActiveWndExists then lcPropPutBool(TFormChild(ActiveMDIChild).hLcWnd,LC_PROP_WND_OSNAP,Integer(ButtonOSnap.Down));
end;

// Grid snap (F9)
procedure TFormMain.ButtonSnapClick(Sender: TObject);
begin
  if ActiveWndExists then lcPropPutBool(TFormChild(ActiveMDIChild).hLcWnd,LC_PROP_WND_GRIDSNAP,Integer(ButtonSnap.Down));
end;

// Orto (F2)
procedure TFormMain.ButtonOrtoClick(Sender: TObject);
begin
  if ActiveWndExists then lcPropPutBool(TFormChild(ActiveMDIChild).hLcWnd,LC_PROP_WND_ORTHO,Integer(ButtonOrto.Down));
end;

// Polar tracking (F8)
procedure TFormMain.ButtonPolarClick(Sender: TObject);
begin
  if ActiveWndExists then lcPropPutBool(TFormChild(ActiveMDIChild).hLcWnd,LC_PROP_WND_PTRACK,Integer(ButtonPolar.Down));
end;

// Full screen mode
procedure TFormMain.FullScreenMode;
begin
  LCRibbon.Minimized        := not LCRibbon.Minimized;
  ButtonFullScreen.Down     := LCRibbon.Minimized;
  if ActiveWndExists then TFormChild(ActiveMDIChild).WndFocus;
end;

procedure TFormMain.ButtonFullScreenClick(Sender: TObject);
begin
  FullScreenMode
end;
{$ENDREGION 'Bottom Tools'}

{$REGION 'Tab File Actions'}
// New LiteCAD document
procedure TFormMain.ActionFileNewExecute(Sender: TObject);
begin
  CreateMDIChild(GetNewFileName);
end;

// Open LiteCAD document
procedure TFormMain.ActionFileOpenExecute(Sender: TObject);
begin
  if OpenDialog.Execute then
    begin
      CreateMDIChild(EmptyStr);
      if ActiveWndExists then
        if not TFormChild(ActiveMDIChild).FileOpen(OpenDialog.FileName) then ActiveMDIChild.Close
    end;
end;

// Open Recent LiteCAD document
procedure TFormMain.ActionFileOpenRecentExecute(Sender: TObject);
begin
  CreateMDIChild(EmptyStr);
  if ActiveWndExists then
    if not TFormChild(ActiveMDIChild).FileOpenRecent then ActiveMDIChild.Close
end;

// Save LiteCAD document
procedure TFormMain.ActionFileSaveExecute(Sender: TObject);
begin
  if ActiveWndExists then TFormChild(ActiveMDIChild).FileSave(LC_CMD_FILESAVE)
end;

// Save As LiteCAD document
procedure TFormMain.ActionFileSaveAsExecute(Sender: TObject);
begin
  if ActiveWndExists then TFormChild(ActiveMDIChild).FileSave(LC_CMD_FILESAVEAS)
end;

// Close current LiteCAD document
procedure TFormMain.ActionFileCloseExecute(Sender: TObject);
begin
  if ActiveWndExists then ActiveMDIChild.Close
end;

// Exit
procedure TFormMain.ActionFileExitExecute(Sender: TObject);
begin
  Close
end;
{$ENDREGION 'Tab File Actions'}

{$REGION 'Tab Draw Actions'}
// Actions with CmdParam in lcWndExeCommand
procedure TFormMain.ActionDrawCircleRExecute(Sender: TObject);
begin
  ActiveWndFocus;
  lcWndExeCommand(ActiveWnd,LC_CMD_CIRCLE,LC_CIRCLE_CR);
end;

procedure TFormMain.ActionDrawCircle2Execute(Sender: TObject);
begin
  ActiveWndFocus;
  lcWndExeCommand(ActiveWnd,LC_CMD_CIRCLE,LC_CIRCLE_2P);
end;

procedure TFormMain.ActionDrawCircle3Execute(Sender: TObject);
begin
  ActiveWndFocus;
  lcWndExeCommand(ActiveWnd,LC_CMD_CIRCLE,LC_CIRCLE_3P);
end;

procedure TFormMain.ActionDrawEllipseAXExecute(Sender: TObject);
begin
  ActiveWndFocus;
  lcWndExeCommand(ActiveWnd,LC_CMD_ELLIPSE,LC_ELL_AX)
end;

procedure TFormMain.ActionDrawEllipseCENExecute(Sender: TObject);
begin
  ActiveWndFocus;
  lcWndExeCommand(ActiveWnd,LC_CMD_ELLIPSE,LC_ELL_CEN)
end;

procedure TFormMain.ActionDrawEllipseRECTExecute(Sender: TObject);
begin
  ActiveWndFocus;
  lcWndExeCommand(ActiveWnd,LC_CMD_ELLIPSE,LC_ELL_RECT)
end;

procedure TFormMain.ActionDrawLineSerialExecute(Sender: TObject);
begin
  ActiveWndFocus;
  lcWndExeCommand(ActiveWnd,LC_CMD_LINE,LC_LINE_SERIAL);
end;

procedure TFormMain.ActionDrawLineSeparateExecute(Sender: TObject);
begin
  ActiveWndFocus;
  lcWndExeCommand(ActiveWnd,LC_CMD_LINE,LC_LINE_SEPARATE);
end;

procedure TFormMain.ActionDrawLineRayExecute(Sender: TObject);
begin
  ActiveWndFocus;
  lcWndExeCommand(ActiveWnd,LC_CMD_XLINE,LC_XLINE_RAY);
  lcWndExeCommand(ActiveWnd,LC_CMD_XLINE,LC_XLINE_BASE);
end;

procedure TFormMain.ActionDrawLineConstructionExecute(Sender: TObject);
begin
  ActiveWndFocus;
  lcWndExeCommand(ActiveWnd,LC_CMD_XLINE,LC_XLINE_XLINE);
  lcWndExeCommand(ActiveWnd,LC_CMD_XLINE,LC_XLINE_BASE);
end;

procedure TFormMain.ActionDrawRectangle2Execute(Sender: TObject);
begin
  ActiveWndFocus;
  lcWndExeCommand(ActiveWnd,LC_CMD_RECT,LC_RECT_2P)
end;

procedure TFormMain.ActionDrawRectangle3Execute(Sender: TObject);
begin
  ActiveWndFocus;
  lcWndExeCommand(ActiveWnd,LC_CMD_RECT,LC_RECT_3P)
end;

procedure TFormMain.ActionDrawRectangleCSAExecute(Sender: TObject);
begin
  ActiveWndFocus;
  lcWndExeCommand(ActiveWnd,LC_CMD_RECT,LC_RECT_CSA)
end;

procedure TFormMain.ActionDrawArcSMEExecute(Sender: TObject);
begin
  ActiveWndFocus;
  lcWndExeCommand(ActiveWnd,LC_CMD_ARC,LC_ARC_SME);
end;

procedure TFormMain.ActionDrawArcSEMExecute(Sender: TObject);
begin
  ActiveWndFocus;
  lcWndExeCommand(ActiveWnd,LC_CMD_ARC,LC_ARC_SEM);
end;

procedure TFormMain.ActionDrawArcSECExecute(Sender: TObject);
begin
  ActiveWndFocus;
  lcWndExeCommand(ActiveWnd,LC_CMD_ARC,LC_ARC_SEC);
end;

procedure TFormMain.ActionDrawArcSEDExecute(Sender: TObject);
begin
  ActiveWndFocus;
  lcWndExeCommand(ActiveWnd,LC_CMD_ARC,LC_ARC_SED);
end;

procedure TFormMain.ActionDrawArcCSEExecute(Sender: TObject);
begin
  ActiveWndFocus;
  lcWndExeCommand(ActiveWnd,LC_CMD_ARC,LC_ARC_CSE);
end;

procedure TFormMain.ActionDrawArcCONTExecute(Sender: TObject);
begin
  ActiveWndFocus;
  lcWndExeCommand(ActiveWnd,LC_CMD_ARC,LC_ARC_CONT);
end;
{$ENDREGION 'Tab Draw Actions'}

{$REGION 'Modify Actions'}
// Copy, Alignment, Order
// Execute LiteCAD command by Sender Tag param
// Copy Tag = LC_COPY_... in LiteCAD.pas
// Alignment Tag = LC_ALIGN_... in LiteCAD.pas
// Order Tag = LC_ORDER... in LiteCAD.pas

// Copy
procedure TFormMain.CopyExecute(Sender: TObject);
begin
  ActiveWndFocus;
  if (Sender is TMenuItem) then lcWndExeCommand(ActiveWnd,LC_CMD_COPY,(Sender as TMenuItem).Tag)
    else if (Sender is TAction) then lcWndExeCommand(ActiveWnd,LC_CMD_COPY,(Sender as TAction).Tag)
end;

// Alignment
procedure TFormMain.AlignmentExecute(Sender: TObject);
begin
  ActiveWndFocus;
  if (Sender is TMenuItem) then lcWndExeCommand(ActiveWnd,LC_CMD_ALIGN,(Sender as TMenuItem).Tag)
    else if (Sender is TAction) then lcWndExeCommand(ActiveWnd,LC_CMD_ALIGN,(Sender as TAction).Tag)
end;

// Order
procedure TFormMain.OrderExecute(Sender: TObject);
begin
  ActiveWndFocus;
  if (Sender is TMenuItem) then lcWndExeCommand(ActiveWnd,LC_CMD_ORDER,(Sender as TMenuItem).Tag)
    else if (Sender is TAction) then lcWndExeCommand(ActiveWnd,LC_CMD_ORDER,(Sender as TAction).Tag)
end;
{$ENDREGION 'Modify Actions'}

{$REGION 'Tab View Actions'}
// Switch Windows
procedure TFormMain.ActionViewSwitchWindowsExecute(Sender: TObject);
begin
  Next;
  ActiveWndFocus
end;

// Tile Horizontally
procedure TFormMain.ActionViewTileHorExecute(Sender: TObject);
begin
  TileMode := tbHorizontal;
  Tile;
  ActiveWndFocus
end;

// Tile Vertically
procedure TFormMain.ActionViewTileVertExecute(Sender: TObject);
begin
  TileMode := tbVertical;
  Tile;
  ActiveWndFocus
end;

// Cascade
procedure TFormMain.ActionViewCascadeExecute(Sender: TObject);
begin
  Cascade;
  ActiveWndFocus
end;

// Minimize all
procedure TFormMain.ActionViewMinimizeAllExecute(Sender: TObject);
  var
    i: Integer;
    Forms: array of TForm;
begin
  SetLength(Forms, MDIChildCount);
  for i := 0 to high(Forms) do Forms[i] := MDIChildren[i];
  for i := 0 to high(Forms) do Forms[i].WindowState := wsMinimized;
end;

// Show Properties
procedure TFormMain.ActionViewPropertiesExecute(Sender: TObject);
begin
//  if ActiveWndExists then
  PanelProperties.Visible:=ActionViewProperties.Checked;
end;

// Show Rulers
procedure TFormMain.ActionViewRulersExecute(Sender: TObject);
  var i: Integer;
begin
  for i := 0 to MDIChildCount-1 do TFormChild(MDIChildren[i]).Ruler(ToolButtonRuler.Down)
end;

// Magnifier
procedure TFormMain.ActionViewMagnifierExecute(Sender: TObject);
begin
  if ActiveWndExists then TFormChild(ActiveMDIChild).Magnifier
end;

// Aerial View
procedure TFormMain.ActionViewAerialExecute(Sender: TObject);
begin
  if ActiveWndExists then TFormChild(ActiveMDIChild).Aerial
end;

// Show/Hide Classic ToolBar
procedure TFormMain.ActionViewClassicToolBarExecute(Sender: TObject);
begin
  ToolBarLiteCADTop.Visible   := ActionViewClassicToolBar.Checked;
  ToolBarLiteCADRight.Visible := ActionViewClassicToolBar.Checked;
end;
{$ENDREGION 'Tab View Actions'}

{$REGION 'Tab Help Actions'}
// Open Help File
procedure TFormMain.ActionHelpExecute(Sender: TObject);
begin
  Application.HelpContext(0)
end;

// LiteCAD API Reference
procedure TFormMain.ActionHelpAPIReferenceExecute(Sender: TObject);
begin
  Application.HelpContext(0)
// Application.HelpKeyword('keyword')
// Application.HelpJump('topic')
end;

// About
procedure TFormMain.ActionHelpAboutExecute(Sender: TObject);
begin
  if Not Assigned(AboutForm) then Application.CreateForm(TAboutForm,AboutForm);
  try
    if (AboutForm.ShowModal = mrOk) then ;
  finally
    FreeAndNil(AboutForm);
    ActiveWndFocus
  end
end;
{$ENDREGION 'Tab Help Actions'}

// Open ToolBar Drop Down Menus on Click
procedure TFormMain.DropDownMenuClick(Sender: TObject);
begin
  (Sender as TToolButton).CheckMenuDropdown;
end;

// Execute LiteCAD command by Sender Tag param
// TObject Tag = LC_CMD_... in LiteCAD.pas
procedure TFormMain.ActionLCExecute(Sender: TObject);
begin
  ActiveWndFocus;
  if (Sender is TMenuItem) then lcWndExeCommand(ActiveWnd,(Sender as TMenuItem).Tag,0)
    else if (Sender is TAction) then lcWndExeCommand(ActiveWnd,(Sender as TAction).Tag,0)
      else if (Sender is TToolButton) then lcWndExeCommand(ActiveWnd,(Sender as TToolButton).Tag,0);
end;

end.
